#include<migos_stdio.h>
#include<application.h>

/* A structure for an application class infomation. 
 * name : Class name
 * app_class : An actual object for INSTANCE_CLASS structure 
 */

/*Application Class Table */
struct ac act_g[MAX_NUM_APPLICATION_CLASSES];
int ac_count_g = 0;


DECLARE_APP_CLASS(Hello);



void register_application_classes(void)
{
		kernel_printf("Registering Application classes.............\n");
		add_app_class("Hello", Hello);
}


int add_app_class(char *name, INSTANCE_CLASS class)
{
		int ret = 0;

		if(ac_count_g >= MAX_NUM_APPLICATION_CLASSES){
				ret = -1;
				goto no_more_class;
		}

		strcpy(act_g[ac_count_g].name,name);
		act_g[ac_count_g].app_class = class;
		ac_count_g++;
		ret = 1;

no_more_class:
		return ret;
}


INSTANCE_CLASS find_app_class_obj(char *name)
{
		struct ac *iter = act_g;
		int i = 0;

		while(i < ac_count_g){
				if(!strcmp(name,iter->name)){
						return iter->app_class;
				}
				iter++;
				i++;
		}
		kernel_printf("Cannot find application class \n");


		return NULL;
}

int is_appclass_exist(char *name)
{
		int found = 0;
		int i;


		for(i = 0; i < ac_count_g; i++ ){
				if(!strcmp(name,act_g[i].name)){
						found = 1;
						break;
				}
		}

		return found;
}


