//------------------------------------------------------------------------------
// ȭϸ : console.c
//    : ezBoot ܼ ø  ƾ̴. 
// 
// ۼ :  ̸() freefrug@falinux.com
// ۼ : 2007 09 14
// ۱ : ̸()
//    : 
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
//    : ü
//    : type  2008.08.24
//------------------------------------------------------------------------------


//#include <arch.h>
//#include <timer.h>

#include <types.h>
#include <arch/pxa255.h>
#include <dev/serial/console.h>
// #include <stdio.h>

//------------------------------------------------------------------------------
//  : ø ̽ ʱȭ Ѵ. 
//  : 
//------------------------------------------------------------------------------
void console_init(int32u baudrate )
{
	unsigned int quot = 0;

	switch( baudrate )
	{
	case BAUD_4800   : quot = 192; break;
	case BAUD_9600   : quot =  96; break;
	case BAUD_19200  : quot =  48; break;
	case BAUD_38400  : quot =  24; break;
	case BAUD_57600  : quot =  16; break;
	case BAUD_115200 : quot =   8; break;
	case BAUD_230400 : quot =   4; break;
	}
	
	CKEN |= CKEN5_STUART;				
	set_PXA255_GPIO_mode( GPIO46_STRXD_MD );
	set_PXA255_GPIO_mode( GPIO47_STTXD_MD );

	// ͷƮ 
	STIER = 0;
	
	// FIFO  Ѵ. 
	STFCR = 7;					
	STFCR = 1;					
	
	// baud, 8BIT 1STOP NO PARITY  Ѵ.
	STLCR = (LCR_WLS1|LCR_WLS0|LCR_DLAB);

	STDLL = quot;
	STDLH = 0x00;
    
	STLCR = (LCR_WLS1|LCR_WLS0); 

	// UART  Ų. 
	STIER = IER_UUE;
}

//------------------------------------------------------------------------------
//  : ַܼ  ڸ Ѵ. 
// Ű : c :  
//------------------------------------------------------------------------------
void console_putc( int8u c )
{
	//  Ҷ ٸ. 
	while(( STLSR & LSR_TDRQ ) == 0 ); 

	// ø Ÿ Ѵ. 
	STTHR = c;
}

//------------------------------------------------------------------------------
//  : ַܼ ڿ Ѵ. 
// Ű : str :  ڿ		/ size : ڿ 
// ȯ : size
// Taxoo ۼ 2008.08.25
//------------------------------------------------------------------------------
int32u console_puts( int8u *str, int32u size )
{
	int32u lp;
	
	for(lp = 0 ; lp < size ; lp++)
		console_putc(str[lp]);
	
	return lp;
}

//------------------------------------------------------------------------------
//  : New Line ½  ó Ŀ  Ѵ.
// Ű : c :  
// Taxoo ۼ 2008.08.25
//------------------------------------------------------------------------------
void console_putc_checkCR( const int8u c  )
{
	console_putc( c );
	if(c == '\n') console_putc('\r');
}

//------------------------------------------------------------------------------
//  : New Line ½  ó Ŀ  Ѵ.
// Ű : str :  ڿ		/ size : ڿ 
// ȯ : size
// Taxoo ۼ 2008.08.25
//------------------------------------------------------------------------------
int32u console_puts_checkCR( int8u *str, int32u size )
{
	int32u lp;
	
	for(lp = 0 ; lp < size ; lp++)
		console_putc_checkCR(str[lp]);
	
	return lp;
}

//------------------------------------------------------------------------------
//  : ַܼ  ѹڸ о ϼ ִ° üũѴ.
// ȯ : ŵ Ÿ  1 /  0
//------------------------------------------------------------------------------
int32u console_read_ok( void )
{
	int32u state;
	
	state = STLSR;
	
	// ŵ Ÿ ִ° ȮѴ. 
	if( state & LSR_DR ) return 1;
		
	return 0;
}
//------------------------------------------------------------------------------
//  : ַܼ  ѹڸ о δ.  
//  :  
//------------------------------------------------------------------------------
int8u console_getc( void )
{
    int8u	rxd = (int8u) STRBR;
	
	return rxd;
}


//------------------------------------------------------------------------------
//  : GPIO  ΰ Ѵ.
//  :
// Taxoo : ezboot_v22 board_config.c . 2008.08.24
//------------------------------------------------------------------------------
void set_PXA255_GPIO_mode(int gpio_mode)
{
	int gpio = gpio_mode & GPIO_MD_MASK_NR;
	int fn = (gpio_mode & GPIO_MD_MASK_FN) >> 8;
	int gafr;

	if (gpio_mode & GPIO_MD_MASK_DIR)
		GPDR(gpio) |=  GPIO_bit(gpio);
	else
		GPDR(gpio) &= ~GPIO_bit(gpio);

	gafr = GAFR(gpio) & ~(0x3 << (((gpio) & 0xf)*2));
	GAFR(gpio) = gafr |  (fn  << (((gpio) & 0xf)*2));
}
