#ifndef _CPU_H
#define _CPU_H

#define context_sw(prev, next)	__asm { \
}

#define  enter_critical_section()  {cpu_sr = save_cpsr(); }
#define  exit_critical_section()   { restore_cpsr(cpu_sr);}

extern unsigned int save_cpsr(void);
extern void restore_cpsr(unsigned int);

extern void enable_interrupt(void);
extern void disable_interrupt(void);


extern void load_context(unsigned int);
extern void context_switch(unsigned int,unsigned int);

#endif //_CPU_H
