/*
   by bro(bro@shinbiro.com)
   Kyung Min, Cho
   2004/10/29
*/
#ifndef __TOUCH_H__
#define __TOUCH_H__
#include<arch/cpu.h>

/*	  Ƶ -taxoo-
#define MK712_LOCK					disable_irq()
#define MK712_UNLOCK				enable_irq()
*/

#define MK712_LOCK					enter_critical_section()
#define MK712_UNLOCK				exit_critical_section()


#define MK712_STATUS_DOWN                       0
#define MK712_STATUS_MOVE                       1
#define MK712_STATUS_UP                         2
 
#define MAX_MK712_DATA                          20 // 내부 입력 버퍼
#define MK712_SKIP_PIXEL			5  // 손가락 흔들림 무시 --; 

// IRQ  ʾƼ  
#define IRQ_FUNCTION		1
void temp_taxoo(void);




void init_touch( void );
void touch_ack( void );
void setup_touch( void );

// poll method
void touch_poll( void );

int touch_get_event( int* x, int* y, int* status );
void touch_handler(void);
#endif 
