/*
   circluar queue array
   --------------------
   by Kyung Min,Cho 
   bro(bro@shinbiro.com) 
   2004/10/29
*/
#ifndef __CQA_H__
#define __CQA_H__

#define CQA_DATA		unsigned int
#define CQA_EMPTY		(-1)

typedef struct _cqa
{
	CQA_DATA* array;
	int count;
	int top;
	int bottom;
}cqa;


void cqa_init( struct _cqa* cq, void* array, int count );
void cqa_push( struct _cqa* cq, CQA_DATA data );
CQA_DATA cqa_pop( cqa* cq );


#endif
