
		PRESERVE8
		AREA   INIT, CODE, READONLY                     ; Name this block of code                                   ;

		GLOBAL _timer_hand

	
_Exit_irq FUNCTION
;// Previous task's context push

;// I-bit clear
		mrs	r11, cpsr
		bic	r11, r11, #0x80
		msr	cpsr_cxsf, r11

		mov pc, lr
		ENDFUNC



_timer_hand 
;I-bit set
		mrs	r11, cpsr
		orr	r11, r11, #0x80
		msr	cpsr_cxsf, r11

		movs pc, lr

;change from IRQ mode to SYS mode
		LDR	r0, =_Exit_irq
		movs	pc, r0




		END


