#include<arch/pxa255.h>


#define ONE_SECOND	3686400
#define ONE_MILLISECOND		3686
#define ONE_MICROSECOND		3

void init_time(void)
{

	ICPR = (ICPR | (1 << 26));
	ICMR = (ICMR | (1 << 26));

	OSCR = 0;

	OIER = 0;		

	while(OSCR == 0); 	/* time delay */

	OSMR0 = 0;
	OSSR = 0xf;

	OSSR = OSSR_M0;
	OSMR0 = OSCR + ONE_SECOND/2;

	OIER = OSSR_M0;
}




inline void reset_tick(void)
{
	OSSR = OSSR_M0;
	OSMR0 = OSCR + ONE_MILLISECOND;
}
