#include <arch/arch.h>
#include <arch/cpu.h>
#include <kernel/mm.h>
#include <kernel/process.h>
#include <kernel/thread.h>
#include <kernel/schedule.h>
#include <kernel/vfs.h>
#include <kernel/resource.h>
#include <dev/serial/console.h>
#include <dev/touch/touch.h>
#include <kernel/timer.h>
#include <kernel/sync.h>
#include <fs/fat.h>
#include <gui/gs.h>
#include <application.h>
#include <kernel/shell.h>

/*Headers for Java Virtual Machine */
#include <global.h>


#if 1
	#include<migos_stdio.h>
	#define kernel_printf	migos_printf
#else

	#define kernel_printf
#endif // RVDS_PORT



/* Function declarations */
static void migos_kernel_start(void);
extern void	init_clock(void);
extern void	enable_clock(void);



/* Global Variable Declarations */


/* Static Variable Declarations */






/* Functions */
extern void vfs_test_routine(void);

/* start.S  migos_kernel_start() Ѿ  ¡˴ٸ.
   RVDS ڵ main() ϱ  ӽ÷ ־.
   - Joongyu
*/ 
#if 1
int main()
{
	
	migos_kernel_start();
}
	
#endif

void test_kernel_thread1()
{
//	create_jvm_process(3,"main class", 0);

	while(1){
			;
	}
}

void test_kernel_thread()
{
		int i = 0;
		for(i = 0; i < 10; i++){
				kernel_printf("test kernel thread : %s \n",get_current_thread()->name);
		}
		while(1){
				;
		}
}





/* Ŀ  ƾ
 *   ý ʱȭ  Ŀ , ڹ μ / Ѵ. 
 * - Joongyu
 */
void migos_kernel_start(void)
{


	extern void vfs_test_routine(void);
	extern void kmem_test_routine(void);
	extern struct thread *touch_handler_thread;
	extern int get_touch();


	disable_interrupt();
	setup_arch();

	/* Kernel boot up message */
	kernel_printf("This is MIGOS Kernel \n");

	init_sched();
	setup_swapper();
	kmem_test_routine();
	init_timer();
	vfs_test_routine();
	init_fs();
	init_gs();

	register_application_classes();

	kernel_printf("Creating kernel threads......\n");
	create_kernel_thread(1, "Shell", shell, NORMAL, 1);
	create_kernel_thread(2, "Idle thread", test_kernel_thread1, NORMAL,  1);
	touch_handler_thread = create_kernel_thread(10, "touch handler",get_touch, REALTIME, 1);

	//create_jvm_process(3,"Hello", 0);


	//init_clock();
	//enable_clock();
	
	kernel_printf("Enabling interrupt........\n");
	enable_interrupt();
	
	kernel_printf("Now, start thread scheduling........\n");
	start_sched();
	
	
	//usleep(10);
	volatile int i = 0;
	while(1)
	{
			i++;
//			printf("%d hahahahahha\n",i);
		
		;
	}
	
}
