#include <kni.h>
#include <stdio.h>
#include <win32app_export.h>


KNIEXPORT KNI_RETURNTYPE_BOOLEAN Java_com_sun_midp_lcdui_DisplayDeviceAccess_toggleBacklight0() {
    int displayId = KNI_GetParameterAsInt(1);
    KNI_ReturnVoid();
}

/**
 * IMPL_NOTE:(Deoxy - Consider using internal)
 *
 * IMPL_NOTE:(Deoxy - Consider using verbatim)
 * FUNCTION:      isBacklightSupported (II)Z
 * CLASS:         com.sun.midp.lcdui.DisplayDeviceAccess
 * TYPE:          virtual native function
 * OVERVIEW:      tests if backlight supported
 * INTERFACE (operand stack manipulation):
 *   parameters:  displayId The display ID associated with the caller Display
 *
 *   returns:     KNI_TRUE if backlight is controllable,
 *                KNI_FALSE otherwise
 * IMPL_NOTE:(Deoxy - Consider using endverbatim)
 */
KNIEXPORT KNI_RETURNTYPE_BOOLEAN Java_com_sun_midp_lcdui_DisplayDeviceAccess_isBacklightSupported0() {
    int displayId = KNI_GetParameterAsInt(1);
    KNI_ReturnVoid();
}

KNIEXPORT KNI_RETURNTYPE_VOID com_sun_midp_main_IndicatorManager_toggleHomeIcon0() {
  
	KNI_ReturnVoid();
}