#ifndef _APPLICATION_H
#define _APPLICATION_H
#include<global.h>

#define	DECLARE_APP_CLASS(name)		extern INSTANCE_CLASS name
#define	MAX_NUM_APPLICATION_CLASSES		(10)	// Maximum number of java application classes
#define	MAX_CLASS_NAME_LENGTH			(32)	// Maximum number of java application classes

struct ac {
		char name[MAX_CLASS_NAME_LENGTH];
		INSTANCE_CLASS app_class;
};


void register_application_classes(void);
int add_app_class(char *name, INSTANCE_CLASS class);
INSTANCE_CLASS find_app_class_obj(char *name);
int is_appclass_exist(char *name);

extern int ac_count_g;
extern struct ac act_g[MAX_NUM_APPLICATION_CLASSES];

#endif // _APPLICATION_H
