//------------------------------------------------------------------------------
// ȭϸ : cs8900.c
//    : ̴Ĩ cs8900 Ѵ.
// ۼ : â ()̴Ƽ frog@falinux.com
// ۼ : 2001 10 8
//    : 2003 05 20  pxa255   
// ۱ : ()̴Ƽ 
//    : 
//------------------------------------------------------------------------------

//******************************************************************************
//
//  
//
//******************************************************************************

#include <types.h>
#include <pxa255.h>
#include <stdio.h>
//#include <string.h>
#include <mem_map.h>
#include <cs8900.h>

#include <kernel/error.h>
//#include "uip.h"

#if 0
#include <config.h>
#endif
//******************************************************************************
//
//   
//
//******************************************************************************


//------------------------------------------------------------------------------
//  :   巹 ּҸ ´. 
// Ű : 
// ȯ :  巹 
//  : 
//------------------------------------------------------------------------------
int8u *CS8900_GetMacAddress( void ) 
{
//  	return Cfg.Local_MacAddress;
	return (int8u *)1;
}

//------------------------------------------------------------------------------
//  : IO mode packet page point addr(packet page address) , 
//        IO mode packet page data value(packet page data) Ἥ  ٲ۴.
// Ű : addr  : packet page ּ.
//        value : packet page ּ ġ  .
// ȯ : .
//  : .
//------------------------------------------------------------------------------
static void CS8900_WriteToPPR(int16s addr, int16s value)
{
	CS8900_PPPTR = addr;
	CS8900_PPDATA = value;
	return;
}	

//------------------------------------------------------------------------------
//  : IO mode packet page point addr(packet page address) , 
//        IO mode packet page data  о returnѴ.
// Ű : addr  : packet page ּ.
// ȯ : packet page addr ִ .
//  :  
//------------------------------------------------------------------------------
static int16s CS8900_ReadFromPPR( int16s addr )
{
	CS8900_PPPTR = addr;
	return CS8900_PPDATA;
}

//------------------------------------------------------------------------------
//  : packet .
//           Ȯ  IO_RTX_DATA packet ݺ .
// Ű : txPktBuf :   巹 
//        len      :  ũ  
// ȯ : packet page addr ִ .
//  :  
//------------------------------------------------------------------------------
int32s CS8900_Transmit( void *txPktBuf, int32s len )
{
#if 1
	int16s *endPtr, *s;
	int32u tick = 0;

	// Ethernet Tx on.
	CS8900_PPPTR = PP_LineCTL;
	CS8900_PPDATA |= SERIAL_TX_ON;

	// packet ü CS8900A   ۽
	CS8900_TXCMD = TX_AFTER_ALL;
	CS8900_TXLEN = len;

	// Tx غ  .
	//printf( "TX-Enter ");
	while ((CS8900_ReadFromPPR(PP_BusST) & READY_FOR_TX_NOW)==0)
	{
        tick++;
        if ( 0 == tick )
        {
            printf( " Error TX BIT\n");
            return FAILED;
        }
	}
	//printf( " TX-Exit\n");

	// CS8900 packet . ̰   CS8900A RJ45 packet  .
	for (s = txPktBuf, endPtr = txPktBuf + len ; s < endPtr ; s++)
    {
		CS8900_RTX_DATA = *s;
        // printf( " %04X", SWAP16(*s) & 0xFFFF );
	}

	return SUCCESS;
#endif
}	
//------------------------------------------------------------------------------
//  :   Ŷ Ѵ. 
//        packet    IO_RTX_DATA state, length, packet  о .
// Ű : 
// ȯ :     /  0 
//  : ip  udp check   ó  ִ receive Լ ȣ.
//------------------------------------------------------------------------------
int32s CS8900_Resive(void *rxPktBuf, int32s max_size )
{
	int32s	i;
	int16u	*s;
	int16s	isq, status, len, cnt;

    isq = CS8900_ISQ;

	//   ߻Ͽ° Ѵ. 
	if( isq & ISQ_RX_MISS_EVENT )
	{
		 printf( "Miss RX\n" );
		 return 0;
	}	 

	//  ̺Ʈ ߻Ͽ° Ѵ. 
	if( isq & ISQ_RECEIVER_EVENT )
    {
            
	    //  ¸ ´.
	    status = CS8900_RTX_DATA;
        len = CS8900_RTX_DATA;  // ŵ ̸ ´.
            
        // printf( "RESIVE EVENT [%04X]\n", status );  
        // printf( "RESIVE LENGTH %d \n", len ); 
           
        // Ͱ Ʋ ϴ о ´.
	    cnt = len/2 + len%2;
	    for (i=0, s=rxPktBuf; i<cnt; i++)
        {
			*s = CS8900_RTX_DATA;
			s++;
                // printf( " [%04X]", SWAP16(*s) );
        }
        if( status & RX_OK ) return len;
	}
	return 0;
}

//------------------------------------------------------------------------------
//  : CS8900 Ʈũ ũ Ǿ ִ° ȮѴ. 
// Ű : 
// ȯ : ũ Ǿ  SUCCESS ϸ FAILED ȯѴ. 
//  : 
//------------------------------------------------------------------------------
int  CS8900_CheckLink( void )
{
    int16u LineState;

    LineState = CS8900_ReadFromPPR( PP_LineST  );
    //printf( "CS8900 Line Link Check\n" ); // 

	// check Link on.
	if( ! ( LineState & LINK_OK ) )
    {
 		return FAILED; //printf("Ethernet Link failed. Check line.\n");
 	}
        return SUCCESS;  //printf("Ethernet Link Ok\n");
}

//------------------------------------------------------------------------------
//  : CS8900 ͷƮ  ʴ IO ʱȭ Ѵ. 
// Ű : 
// ȯ : ϸ SUCCESS ϸ FAILED ȯѴ. 
//  : 
//------------------------------------------------------------------------------
int CS8900_Init( void )
{
    int32s lp;

    int32u DectectID;
    int16u ChipIDLow;
    int16u ChipIDHigh;
    
    printf( "CS8900 Init...............\n" );

    printf( "CS8900 Mac Address   : " );

#if 0
    printf( "[%02X %02X %02X %02X %02X %02X]\n", Cfg.Local_MacAddress[0],Cfg.Local_MacAddress[1],Cfg.Local_MacAddress[2],
                                                 Cfg.Local_MacAddress[3],Cfg.Local_MacAddress[4],Cfg.Local_MacAddress[5] ); 
#endif

//    о CS8900  ϴ ȮѴ.

    CS8900_ENABLE_WORD;        // WORD ＼ ̳̺ Ų. SHBE pin Ŭ
    
    DectectID = CS8900_PPPTR;  // ID  ´.

    printf( "CS8900 DECTECT VALUE : [%08X:%08X]\n", CS8900_DECTECT_MASK, DectectID & CS8900_DECTECT_MASK );
    
    if( ( DectectID & CS8900_DECTECT_MASK ) != CS8900_DECTECT_MASK )
    {
	    printf( "Can't access to Memory of CS8900A.\n");
	    return FAILED;
    }

    // CS8900 Chip ID  ȮѴ. 
    ChipIDLow  = CS8900_ReadFromPPR( PP_ChipID_LOW  );
    ChipIDHigh = CS8900_ReadFromPPR( PP_ChipID_HIGH );

    // Ʈ  Ѵ. 
    ChipIDHigh  = SWAP16( ChipIDHigh  );
    ChipIDLow   = SWAP16( ChipIDLow   );

    //printf( "CS8900 Chip ID       : [%04X:%04X]\n", ChipIDHigh, ChipIDLow ); //  
    //printf( "       PRODUCT ID    : [%04X]\n", ChipIDHigh );                 // Ĩ EISA ϵ ǰ ȣ
    //printf( "       VERSION       : [%04X]\n", ChipIDLow & 0x1F );           // Ĩ 

	if ( ChipIDHigh != CHECK_CHIP_ID_HIGH )
    {
		printf("Ethernet Chip is not CS8900A. Are you use CS8900A.\n");
		return FAILED;
	}

	// ۼ Ұϰ Ѵ. 
	CS8900_WriteToPPR( PP_LineCTL, 0x0000 );  

    //  ͷƮ  Ų. 
	CS8900_WriteToPPR(PP_CS8900_ISAINT, INTRQ_HIGH_IMPEDENCE );   // Interrupt number.  
	CS8900_WriteToPPR(PP_CS8900_ISADMA, DMRQ_HIGH_IMPEDENCE  );   // DMA Channel Number.

    //   ۼ ϵ    ͸ ʱȭ Ѵ. 
    CS8900_WriteToPPR(PP_RxCFG,	RX_OK_ENBL | RX_CRC_ERROR_ENBL);  
    CS8900_WriteToPPR(PP_RxCTL,	RX_OK_ACCEPT | RX_MULTICAST_ACCEPT | RX_IA_ACCEPT | RX_BROADCAST_ACCEPT);
	CS8900_WriteToPPR(PP_TxCFG,	TX_LOST_CRS_ENBL | TX_SQE_ERROR_ENBL | TX_OK_ENBL | TX_LATE_COL_ENBL | TX_JBR_ENBL | TX_ANY_COL_ENBL);
	CS8900_WriteToPPR(PP_TxCMD,	TX_START_ALL_BYTES);
	CS8900_WriteToPPR(PP_BufCFG,	0x0000);
	CS8900_WriteToPPR(PP_BusCTL,	ENABLE_IRQ | IO_CHANNEL_READY_ON);
	CS8900_WriteToPPR(PP_TestCTL,	0x0000);

    //   ʱȭ 
	CS8900_WriteToPPR(PP_TxCommand,0x00c0);

    // MAC 巹   ũ 
    // ⼭   㰡ϰ Ѵ.
	for ( lp = 0 ; lp < 4 ; lp++ )
		CS8900_WriteToPPR( PP_LAF+lp*2, 0xFFFF );

    // MAC 巹 Ѵ.
#if 0
    for ( lp = 0 ; lp < 3 ; lp++ )
    	CS8900_WriteToPPR( PP_IA+lp*2, *((int16u *)&( Cfg.Local_MacAddress[lp*2])));
#endif

    // ۼ ϰ .
    CS8900_WriteToPPR(PP_LineCTL, SERIAL_RX_ON | SERIAL_TX_ON);

    printf( "CS8900 INIT OK!\n\n" );

	return SUCCESS;
}	


void  CS8900_SwReset( void )
{
    CS8900_Init();
    //   ʱȭ
	//	CS8900_WriteToPPR(PP_TxCommand,0x00c0);
}

