#ifndef __LED_H__
#define __LED_H__
#include<arch/ez_x5.h>

#define UART_LSR		((volatile unsigned int) UART[5] )  // 라인 상태 
#define LSR_TDRQ	(1 << 5)	// Transmit Data Request  

//#define __REG(x)	(*((volatile unsigned int *) (x))) 
#define PXA_GP_BASE_REG(offset)	*((volatile unsigned int *) (PXA_REG_GP_BASE+offset))
#define LED_ON(x)		PXA_GP_BASE_REG(PXA_REG_OFFSET_GPCR0) = x
#define LED_OFF(x)		PXA_GP_BASE_REG(PXA_REG_OFFSET_GPSR0) = x


#endif /* __LED__H__ */
