#include<migos_stdio.h>
#include<dev/serial/console.h>
#include<dev/lcd/lcd.h>
#include<arch/arch.h>
#include<fs/nand.h>
#include<dev/touch/touch.h>

void board_init(void);

int setup_arch(void)
{
		kernel_printf("Setting up for architecture specific modules....... ");
		board_init();
		console_init(BAUD_115200);
		init_time();
		init_lcd();
		init_nand();
		init_touch();

//		clock_init()
		//set_defult_intctlr();
		kernel_printf("[ ok ]\n");

		return 1;
}




void  board_init( void )
{
	GPCR(11) = GPIO_bit(11);
	GPCR(12) = GPIO_bit(12);
	GPCR(13) = GPIO_bit(13);
	GPCR(14) = GPIO_bit(14);
	GPCR( 0) = GPIO_bit( 0);
	
	set_PXA255_GPIO_mode( GPIO_OUT | 11 );	// dout0
	set_PXA255_GPIO_mode( GPIO_OUT | 12 );	// dout1
	set_PXA255_GPIO_mode( GPIO_OUT | 13 );	// dout2
	set_PXA255_GPIO_mode( GPIO_OUT | 14 );	// dout3
	set_PXA255_GPIO_mode( GPIO_OUT | 0  );	// buzzer
}
