#include <kni.h>
#include<dev/lcd/lcd.h>
#include <win32app_export.h>
//#include <windows.h>
#if 0
HANDLE hThread1;
HWND hwnd;
#endif

typedef struct _Point
{
		int x;
		int y;
}Point;

void App_CreateWindow() 
{
//	hThread1 = (HANDLE)_beginthreadex(NULL, 0, (unsigned (__stdcall *) (void *))CreateWindows, NULL, 0, NULL); 
//	Sleep(100);
}

#if 0
LRESULT CALLBACK WndProc(HWND hWnd,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	static char str[256];
	int len;
		
	switch(iMessage) {
	case WM_CREATE:
		return 0;
	case WM_CHAR:
			len = strlen(str);
			str[len]=(TCHAR)wParam;
			str[len+1]=0;
			if(wParam=='0')
				//lcdlf_refresh(0,0,80,60);
				InvalidateRect(hWnd,NULL,TRUE);
			return 0;
		case WM_PAINT:
			hdc=BeginPaint(hWnd,&ps);
			TextOut(hdc,100,100,str,strlen(str));
			EndPaint(hWnd,&ps);
			return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	}
	return(DefWindowProc(hWnd,iMessage,wParam,lParam));
}
#endif

int CreateWindows(void *arg)
{
#if 0
    HINSTANCE hInstance = GetModuleHandle(NULL);
    char szAppName[] = "App";
    WNDCLASSEX  wndclass;
	MSG Message;

	wndclass.hbrBackground=(HBRUSH)GetStockObject(LTGRAY_BRUSH);
    wndclass.cbSize        = sizeof (wndclass);
    wndclass.style         = CS_HREDRAW | CS_VREDRAW;
    wndclass.lpfnWndProc   = WndProc;
    wndclass.cbClsExtra    = 0;
    wndclass.cbWndExtra    = 0;
    wndclass.hInstance     = hInstance;
    wndclass.hIcon         = NULL;
    wndclass.hCursor       = NULL;
    wndclass.lpszMenuName  = NULL;
    wndclass.lpszClassName = szAppName;
    wndclass.hIconSm       = NULL;

    RegisterClassEx (&wndclass);

    hwnd = CreateWindow (szAppName,               /* window class name       */
                         "App",                  /* window caption          */
                         WS_OVERLAPPEDWINDOW,             /* window style; disable   */
                         CW_USEDEFAULT,           /* initial x position      */
                         CW_USEDEFAULT,           /* initial y position      */
                         800,                       /* initial x size          */
                         600,                       /* initial y size          */
                         NULL,                    /* parent window handle    */
                         NULL,                    /* window menu handle      */
                         hInstance,               /* program instance handle */
                         NULL);                   /* creation parameters     */

	ShowWindow(hwnd,1);

	while(GetMessage(&Message,0,0,0)) {
			TranslateMessage(&Message);
			DispatchMessage(&Message);
	}
	return 1;
#endif
}


void Graphics_drawLine(int x1,int y1,int x2,int y2)
{

	put_line_16( x1, y1, x2,y2, RGB(0,0,0) );
#if 0
	HDC hdc;
	hdc = GetDC(hwnd);

	MoveToEx(hdc,x1,y1,NULL);
	LineTo(hdc,x2,y2);
	ReleaseDC(hwnd,hdc);
#endif
}

void Graphics_fillRect(int x, int y, int width, int height)
{
#if 0
	RECT rt;
	HDC hdc;
	HBRUSH myBrush;

	hdc = GetDC(hwnd);
	myBrush = CreateSolidBrush(RGB(0,0,0));
	SetRect(&rt,x,y,width,height);
	FillRect(hdc,&rt,myBrush);
	DeleteObject(myBrush);
	ReleaseDC(hwnd,hdc);
#endif
}

void Graphics_drawRect(int x, int y, int width, int height)
{
#if  0
	RECT rt;
	HDC hdc;

	hdc = GetDC(hwnd);
	Rectangle(hdc,x,y,width,height);
	ReleaseDC(hwnd,hdc);
#endif
}

void Graphics_drawRoundRect(int x, int y, int width, int height, int arcWidth, int arcHeight)
{
#if 0
	RECT rt;
	HDC hdc;

	hdc = GetDC(hwnd);
	Ellipse(hdc,x,y,width,height);
	ReleaseDC(hwnd,hdc);
#endif
}

void Graphics_fillRoundRect(int x, int y, int width, int height, int arcWidth, int arcHeight)
{
#if 0
	HDC hdc;
	HBRUSH myBrush, oldBrush;

	hdc = GetDC(hwnd);
	myBrush = CreateSolidBrush(RGB(0,0,0));
	oldBrush = (HBRUSH)SelectObject(hdc,myBrush);
	Ellipse(hdc,x,y,width,height);
	SelectObject(hdc,oldBrush);
	DeleteObject(myBrush);
	ReleaseDC(hwnd,hdc);
#endif
}

void Graphics_drawString(char* str, int x, int y, int anchor)
{
#if 0
	HDC hdc;
	int len;
	len = strlen(str);
	hdc = GetDC(hwnd);
	TextOut(hdc,x,y,str,len);
	ReleaseDC(hwnd,hdc);
#endif
}

